import { backBlockLocation } from '../util/globalVariables';
import { InstaFarmConfig } from './Main';

export const allowedMaterialList = {
	glass: ["glass","black_stained_glass","blue_stained_glass","brown_stained_glass","cyan_stained_glass","gray_stained_glass","green_stained_glass","light_blue_stained_glass","light_gray_stained_glass","lime_stained_glass","magenta_stained_glass","orange_stained_glass","pink_stained_glass","purple_stained_glass","red_stained_glass","white_stained_glass","yellow_stained_glass"],
	leaves: ["acacia_leaves", "azalea_leaves", "azalea_leaves_flowered", "birch_leaves", "cherry_leaves", "dark_leaves", "jungle_leaves", "mangrove_leaves", "leaves", "pale_leaves", "spruce_leaves"],
	general_coral_fan: ["brain_coral_fan", "bubble_coral_fan", "fire_coral_fan", "horn_coral_fan", "tube_coral_fan", "dead_brain_coral_fan", "dead_bubble_coral_fan", "dead_fire_coral_fan", "dead_horn_coral_fan", "dead_tube_coral_fan"],
	planks: ["acacia_planks", "bamboo_planks", "birch_planks", "cherry_planks", "crimson_planks", "dark_oak_planks", "jungle_planks", "mangrove_planks", "oak_planks", "pale_oak_planks", "spruce_planks", "warped_planks"],
	general_terracotta: [ "hardened_clay", "black_terracotta","blue_terracotta","brown_terracotta","cyan_terracotta","gray_terracotta","green_terracotta","light_blue_terracotta","light_gray_terracotta","lime_terracotta","magenta_terracotta","orange_terracotta","pink_terracotta","purple_terracotta","red_terracotta","white_terracotta","yellow_terracotta" ],
	solid_block: [ 'cobblestone', 'cobbled_deepslate', 'blackstone', 'stone', 'stone_bricks', 'deepslate_bricks', 'polished_blackstone_bricks'],
	wool: ['black_wool', 'blue_wool', 'brown_wool', 'cyan_wool', 'gray_wool', 'green_wool', 'light_blue_wool', 'light_gray_wool', 'lime_wool', 'magenta_wool', 'orange_wool', 'pink_wool', 'purple_wool', 'red_wool', 'white_wool', 'yellow_wool']
}
export const farmMap = new Map([
	['farm:bone_meal_farm', {
		event: "farm:no_nether_farm",
		levels: {
			0: {
				width: 23, height: 13, depth: 15,
				yOffset: -1,
				structures: "mystructure:insta_farm/bone_meal0",
				materials: {
					moss_block: 1,
					soul_sand: 1,
					lava_bucket: 2,
					water_bucket: 7,
					slime_ball: 7,
					ice: 8,
					quartz: 11,
					obsidian: 26,
					iron_ingot: 129,
					redstone: 182,
					planks: 332,
					glass: 693,
					solid_block: 1383
				}
			},
			1: {
				width: 23, height: 13, depth: 16,
				yOffset: -1, depthOffset: 8,
				structures: "mystructure:insta_farm/bone_meal1",
				materials: {
					moss_block: 1,
					lava_bucket: 2,
					ice: 5,
					water_bucket: 7,
					slime_ball: 7,
					quartz: 11,
					obsidian: 26,
					iron_ingot: 112,
					redstone: 164,
					planks: 282,
					glass: 487,
					solid_block: 1100
				}
			},
			2: {
				width: 31, height: 13, depth: 16,
				yOffset: -1, offset: -10,
				structures: "mystructure:insta_farm/bone_meal2",
				materials: {
					moss_block: 1,
					lava_bucket: 2,
					slime_ball: 5,
					water_bucket: 7,
					quartz: 11,
					obsidian: 26,
					iron_ingot: 52,
					planks: 191,
					redstone: 206,
					glass: 484,
					solid_block: 985
				}
			},
			3: {
				width: 19, height: 13, depth: 13,
				yOffset: -1, offset: -16, depthOffset: 11,
				structures: "mystructure:insta_farm/bone_meal3",
				materials: {
					moss_block: 1,
					lava_bucket: 2,
					slime_ball: 4,
					quartz: 6,
					water_bucket: 7,
					obsidian: 26,
					iron_ingot: 39,
					planks: 158,
					redstone: 139,
					glass: 346,
					solid_block: 707
				}
			}
		}
	}],
	['farm:cactus_farm', {
		event: "farm:no_nether_farm",
		maxLevel: { level: 14, yOffset: 4, baseLevel: 1 },
		levels: {
			0: {
				width: 19, height: 7, depth: 19,
				depthOffset: 1,
				structures: "mystructure:insta_farm/cactus_farm0",
				materials: {
					ice: 3,
					water_bucket: 4,
					iron_ingot: 5,
					cactus: 64,
					sand: 64,
					planks: 125,
					glass: 530,
					solid_block: 633
				}
			},
			1: {
				width: 19, height: 5, depth: 19,
				yOffset: 6, depthOffset: 1,
				structures: "mystructure:insta_farm/cactus_farmn",
				materials: {
					water_bucket: 4,
					cactus: 64,
					sand: 64,
					planks: 106,
					solid_block: 129,
					glass: 448,
				}
			}
		}
	}],
	['farm:kelp_farm', {
		event: "farm:no_nether_farm",
		maxLevel: { level: 10, yOffset: 4, baseLevel: 2 },
		levels: {
			0: {
				width: 13, height: 5, depth: 6,
				depthOffset: 1,
				structures: "mystructure:insta_farm/kelp_farm0",
				materials: {
					water_bucket: 2,
					kelp: 8,
					quartz: 8,
					iron_ingot: 13,
					redstone: 32,
					planks: 56,
					glass: 130,
					solid_block: 238,
				}
			},
			1: {
				width: 13, height: 5, depth: 6,
				depthOffset: 5,
				structures: "mystructure:insta_farm/kelp_farm1",
				materials: {
					water_bucket: 2,
					kelp: 8,
					iron_ingot: 8,
					quartz: 8,
					redstone: 32,
					planks: 40,
					glass: 103,
					solid_block: 202,
				}
			},
			2: {
				width: 13, height: 5, depth: 10,
				yOffset: 4, depthOffset: 1,
				structures: "mystructure:insta_farm/kelp_farmn",
				materials: {
					water_bucket: 2,
					kelp: 16,
					iron_ingot: 16,
					quartz: 16,
					redstone: 64,
					planks: 80,
					glass: 130,
					solid_block: 368,
				}
			}
		}
	}],
	['farm:bamboo_farm_n', {
		event: "farm:no_nether_farm",
		maxLevel: { level: 9, yOffset: 3, baseLevel: 1 },
		levels: {
			0: {
				width: 13, height: 6, depth: 12,
				structures: "mystructure:insta_farm/bamboo_farm0",
				materials: {
					blaze_rod: 1,
					water_bucket: 1,
					quartz: 8,
					copper_ingot: 27,
					bamboo: 32,
					dirt: 32,
					iron_ingot: 79,
					redstone: 112,
					planks: 320,
					glass: 322,
					solid_block: 440,
				}
			},
			1: {
				width: 13, height: 6, depth: 11,
				yOffset: 4, depthOffset: 1,
				structures: "mystructure:insta_farm/bamboo_farmn",
				materials: {
					blaze_rod: 4,
					quartz: 4,
					bamboo: 32,
					iron_ingot: 32,
					dirt: 32,
					redstone: 76,
					copper_ingot: 108,
					solid_block: 221,
					glass: 260,
					planks: 288,
				}
			}
		}
	}],
	['farm:bamboo_farm_fm', {
		levels: {
			0: {
				width: 19, height: 18, depth: 25,
				offset: -1,
				structures: "mystructure:insta_farm/bamboo_farm_fm0",
				materials: {
					coal: 1,
					obsidian: 2,
					general_terracotta: 2,
					quartz: 8,
					iron_ingot: 49,
					redstone: 51,
					slime_ball: 146,
					planks: 147,
					bamboo: 200,
					dirt: 200,
					solid_block: 484,
					glass: 1450,
				}
			},
			1: {
				width: 16, height: 18, depth: 16,
				offset: -3, depthOffset: 19,
				structures: "mystructure:insta_farm/bamboo_farm_fm1",
				materials: {
					iron_ingot: 1,
					obsidian: 1,
					quartz: 1,
					planks: 5,
					redstone: 14,
					bamboo: 140,
					dirt: 140,
					solid_block: 168,
					glass: 638,
				}
			}
		}
	}],
	['farm:sugar_cane_farm_n', {
		event: "farm:no_nether_farm",
		maxLevel: { level: 9, yOffset: 5, baseLevel: 1 },
		levels: {
			0: {
				width: 13, height: 6, depth: 10,
				depthOffset: 1,
				structures: "mystructure:insta_farm/sugar_cane_farm0",
				materials: {
					water_bucket: 2,
					sugar_cane: 32,
					quartz: 32,
					mud: 32,
					redstone: 120,
					iron_ingot: 207,
					glass: 224,
					planks: 384,
					solid_block: 576,
				}
			},
			1: {
				width: 13, height: 10, depth: 10,
				yOffset: 1, depthOffset: 1,
				structures: "mystructure:insta_farm/sugar_cane_farmn",
				materials: {
					water_bucket: 2,
					mud: 32,
					quartz: 32,
					sugar_cane: 32,
					redstone: 120,
					glass: 225,
					iron_ingot: 232,
					planks: 416,
					solid_block: 482,
				}
			}
		}
	}],
	['farm:sugar_cane_farm_fm', {
		event: "farm:no_nether_farm",
		levels: {
			0: {
				width: 19, height: 7, depth: 25,
				offset: -1,
				structures: "mystructure:insta_farm/sugar_cane_fm0",
				materials: {
					coal: 1,
					water_bucket: 2,
					general_terracotta: 2,
					obsidian: 2,
					quartz: 8,
					iron_ingot: 49,
					redstone: 51,
					slime_ball: 146,
					planks: 147,
					sugar_cane: 160,
					dirt: 160,
					solid_block: 428,
					glass: 685,
				}
			},
			1: {
				width: 16, height: 7, depth: 16,
				offset: -3, depthOffset: 19,
				structures: "mystructure:insta_farm/sugar_cane_fm1",
				materials: {
					iron_ingot: 1,
					obsidian: 1,
					quartz: 1,
					water_bucket: 2,
					planks: 5,
					redstone: 14,
					dirt: 112,
					sugar_cane: 112,
					solid_block: 161,
					glass: 286,
				}
			}
		}
	}],
	['farm:wheat_farm', {
		event: "farm:no_nether_farm",
		levels: {
			0:{
				width: 12, height: 5, depth: 14,
				offset: -1,
				structures: "mystructure:insta_farm/wheat_farm0",
				materials: {
					water_bucket: 9,
					redstone: 31,
					iron_ingot: 45,
					wheat_seeds: 71,
					dirt: 71,
					glass: 129,
					planks: 132,
					solid_block: 306,
				}
			},
			1:{
				width: 12, height: 5, depth: 10,
				offset: -1, yOffset: 1, depthOffset: 11,
				structures: "mystructure:insta_farm/wheat_farmn",
				materials: {
					water_bucket: 9,
					planks: 15,
					redstone: 27,
					wheat_seeds: 62,
					dirt: 62,
					glass: 89,
					solid_block: 173,
				}
			},
			2:{
				width: 12, height: 5, depth: 10,
				offset: -1, yOffset: 2, depthOffset: 18,
				structures: "mystructure:insta_farm/wheat_farmn",
				materials: {
					water_bucket: 9,
					planks: 15,
					redstone: 27,
					wheat_seeds: 62,
					dirt: 62,
					glass: 89,
					solid_block: 173,
				}
			},
			3:{
				width: 12, height: 5, depth: 10,
				offset: -1, yOffset: 3, depthOffset: 25,
				structures: "mystructure:insta_farm/wheat_farmn",
				materials: {
					water_bucket: 9,
					planks: 15,
					redstone: 27,
					wheat_seeds: 62,
					dirt: 62,
					glass: 89,
					solid_block: 173,
				}
			},
			4:{
				width: 12, height: 5, depth: 10,
				offset: -1, yOffset: 4, depthOffset: 32,
				structures: "mystructure:insta_farm/wheat_farmn",
				materials: {
					water_bucket: 9,
					planks: 15,
					redstone: 27,
					wheat_seeds: 62,
					dirt: 62,
					glass: 89,
					solid_block: 173,
				}
			}
		}
	}],
	['farm:beetroot_farm', {
		event: "farm:no_nether_farm",
		levels: {
			0:{
				width: 12, height: 5, depth: 14,
				offset: -1,
				structures: "mystructure:insta_farm/beetroot_farm0",
				materials: {
					water_bucket: 9,
					redstone: 31,
					iron_ingot: 45,
					beetroot_seeds: 71,
					dirt: 71,
					glass: 129,
					planks: 132,
					solid_block: 306,
				}
			},
			1:{
				width: 12, height: 5, depth: 10,
				offset: -1, yOffset: 1, depthOffset: 11,
				structures: "mystructure:insta_farm/beetroot_farmn",
				materials: {
					water_bucket: 9,
					planks: 15,
					redstone: 27,
					beetroot_seeds: 62,
					dirt: 62,
					glass: 89,
					solid_block: 173,
				}
			},
			2:{
				width: 12, height: 5, depth: 10,
				offset: -1, yOffset: 2, depthOffset: 18,
				structures: "mystructure:insta_farm/beetroot_farmn",
				materials: {
					water_bucket: 9,
					planks: 15,
					redstone: 27,
					beetroot_seeds: 62,
					dirt: 62,
					glass: 89,
					solid_block: 173,
				}
			},
			3:{
				width: 12, height: 5, depth: 10,
				offset: -1, yOffset: 3, depthOffset: 25,
				structures: "mystructure:insta_farm/beetroot_farmn",
				materials: {
					water_bucket: 9,
					planks: 15,
					redstone: 27,
					beetroot_seeds: 62,
					dirt: 62,
					glass: 89,
					solid_block: 173,
				}
			},
			4:{
				width: 12, height: 5, depth: 10,
				offset: -1, yOffset: 4, depthOffset: 32,
				structures: "mystructure:insta_farm/beetroot_farmn",
				materials: {
					water_bucket: 9,
					planks: 15,
					redstone: 27,
					beetroot_seeds: 62,
					dirt: 62,
					glass: 89,
					solid_block: 173,
				}
			}
		}
	}],
	['farm:carrot_farm', {
		event: "farm:no_nether_farm",
		levels: {
			0:{
				width: 12, height: 5, depth: 14,
				offset: -1,
				structures: "mystructure:insta_farm/carrot_farm0",
				materials: {
					water_bucket: 9,
					redstone: 31,
					iron_ingot: 45,
					carrot: 71,
					dirt: 71,
					glass: 129,
					planks: 132,
					solid_block: 306,
				}
			},
			1:{
				width: 12, height: 5, depth: 10,
				offset: -1, yOffset: 1, depthOffset: 11,
				structures: "mystructure:insta_farm/carrot_farmn",
				materials: {
					water_bucket: 9,
					planks: 15,
					redstone: 27,
					carrot: 62,
					dirt: 62,
					glass: 89,
					solid_block: 173,
				}
			},
			2:{
				width: 12, height: 5, depth: 10,
				offset: -1, yOffset: 2, depthOffset: 18,
				structures: "mystructure:insta_farm/carrot_farmn",
				materials: {
					water_bucket: 9,
					planks: 15,
					redstone: 27,
					carrot: 62,
					dirt: 62,
					glass: 89,
					solid_block: 173,
				}
			},
			3:{
				width: 12, height: 5, depth: 10,
				offset: -1, yOffset: 3, depthOffset: 25,
				structures: "mystructure:insta_farm/carrot_farmn",
				materials: {
					water_bucket: 9,
					planks: 15,
					redstone: 27,
					carrot: 62,
					dirt: 62,
					glass: 89,
					solid_block: 173,
				}
			},
			4:{
				width: 12, height: 5, depth: 10,
				offset: -1, yOffset: 4, depthOffset: 32,
				structures: "mystructure:insta_farm/carrot_farmn",
				materials: {
					water_bucket: 9,
					planks: 15,
					redstone: 27,
					carrot: 62,
					dirt: 62,
					glass: 89,
					solid_block: 173,
				}
			}
		}
	}],
	['farm:potato_farm', {
		event: "farm:no_nether_farm",
		levels: {
			0:{
				width: 12, height: 5, depth: 14,
				offset: -1,
				structures: "mystructure:insta_farm/potato_farm0",
				materials: {
					water_bucket: 9,
					redstone: 31,
					iron_ingot: 45,
					potato: 71,
					dirt: 71,
					glass: 129,
					planks: 132,
					solid_block: 306,
				}
			},
			1:{
				width: 12, height: 5, depth: 10,
				offset: -1, yOffset: 1, depthOffset: 11,
				structures: "mystructure:insta_farm/potato_farmn",
				materials: {
					water_bucket: 9,
					planks: 15,
					redstone: 27,
					potato: 62,
					dirt: 62,
					glass: 89,
					solid_block: 173,
				}
			},
			2:{
				width: 12, height: 5, depth: 10,
				offset: -1, yOffset: 2, depthOffset: 18,
				structures: "mystructure:insta_farm/potato_farmn",
				materials: {
					water_bucket: 9,
					planks: 15,
					redstone: 27,
					potato: 62,
					dirt: 62,
					glass: 89,
					solid_block: 173,
				}
			},
			3:{
				width: 12, height: 5, depth: 10,
				offset: -1, yOffset: 3, depthOffset: 25,
				structures: "mystructure:insta_farm/potato_farmn",
				materials: {
					water_bucket: 9,
					planks: 15,
					redstone: 27,
					potato: 62,
					dirt: 62,
					glass: 89,
					solid_block: 173,
				}
			},
			4:{
				width: 12, height: 5, depth: 10,
				offset: -1, yOffset: 4, depthOffset: 32,
				structures: "mystructure:insta_farm/potato_farmn",
				materials: {
					water_bucket: 9,
					planks: 15,
					redstone: 27,
					potato: 62,
					dirt: 62,
					glass: 89,
					solid_block: 173,
				}
			}
		}
	}],	
	['farm:melon_farm', {
		event: "farm:no_nether_farm",
		maxLevel: { level: 14, yOffset: 2, baseLevel: 1 },
		levels: {
			0: {
				width: 9, height: 4, depth: 9,
				depthOffset: 1,
				structures: "mystructure:insta_farm/melon_farm0",
				materials: {
					water_bucket: 1,
					melon_seeds: 6,
					quartz: 6,
					iron_ingot: 13,
					dirt: 14,
					redstone: 28,
					planks: 69,
					glass: 71,
					solid_block: 243,
				}
			},
			1: {
				width: 9, height: 3, depth: 9,
				yOffset: 3, depthOffset: 1,
				structures: "mystructure:insta_farm/melon_farmn",
				materials: {
					melon_seeds: 6,
					quartz: 6,
					iron_ingot: 8,
					dirt: 14,
					redstone: 28,
					glass: 71,
					planks: 80,
					solid_block: 169,
				}
			}
		}
	}],
	['farm:pumpkin_farm', {
		event: "farm:no_nether_farm",
		maxLevel: { level: 14, yOffset: 2, baseLevel: 1 },
		levels: {
			0: {
				width: 9, height: 4, depth: 9,
				depthOffset: 1,
				structures: "mystructure:insta_farm/pumpkin_farm0",
				materials: {
					water_bucket: 1,
					pumpkin_seeds: 6,
					quartz: 6,
					iron_ingot: 13,
					dirt: 14,
					redstone: 28,
					planks: 69,
					glass: 71,
					solid_block: 243,
				}
			},
			1: {
				width: 9, height: 3, depth: 9,
				yOffset: 3, depthOffset: 1,
				structures: "mystructure:insta_farm/pumpkin_farmn",
				materials: {
					pumpkin_seeds: 6,
					quartz: 6,
					iron_ingot: 8,
					dirt: 14,
					redstone: 28,
					glass: 71,
					planks: 80,
					solid_block: 169,
				}
			}
		}
	}],
	['farm:twisting_vines_farm_n', {
		maxLevel: { level: 9, yOffset: 5, baseLevel: 1 },
		levels: {
			0: {
				width: 13, height: 6, depth: 10,
				depthOffset: 1,
				structures: "mystructure:insta_farm/twisting_vines_farm0",
				materials: {
					mud: 32,
					quartz: 32,
					twisting_vines: 32,
					redstone: 120,
					iron_ingot: 207,
					glass: 224,
					planks: 384,
					solid_block: 576,
				}
			},
			1: {
				width: 13, height: 10, depth: 10,
				yOffset: 1, depthOffset: 1,
				structures: "mystructure:insta_farm/twisting_vines_farmn",
				materials: {
					mud: 32,
					quartz: 32,
					twisting_vines: 32,
					redstone: 120,
					glass: 225,
					iron_ingot: 232,
					planks: 416,
					solid_block: 482,
				}
			}
		}
	}],
	['farm:twisting_vines_farm_fm', {
		levels: {
			0: {
				width: 19, height: 18, depth: 25,
				offset: -1,
				structures: "mystructure:insta_farm/twisting_vines_fm0",
				materials: {
					coal: 1,
					obsidian: 2,
					general_terracotta: 2,
					quartz: 8,
					iron_ingot: 49,
					redstone: 51,
					slime_ball: 146,
					planks: 147,
					twisting_vines: 200,
					dirt: 200,
					solid_block: 484,
					glass: 1450,
				}
			},
			1: {
				width: 16, height: 18, depth: 16,
				offset: -3, depthOffset: 19,
				structures: "mystructure:insta_farm/twisting_vines_fm1",
				materials: {
					iron_ingot: 1,
					obsidian: 1,
					quartz: 1,
					planks: 5,
					redstone: 14,
					twisting_vines: 140,
					dirt: 140,
					solid_block: 168,
					glass: 638,
				}
			}
		}
	}],
	['farm:weeping_vines_farm', {
		maxLevel: { level: 9, yOffset: 5, baseLevel: 1 },
		levels: {
			0: {
				width: 13, height: 5, depth: 10,
				depthOffset: 1,
				fixStructure: "mystructure:insta_farm/weeping_vines_fix0",
				structures: "mystructure:insta_farm/weeping_vines_farm0",
				materials: {
					quartz: 32,
					weeping_vines: 32,
					redstone: 120,
					glass: 190,
					iron_ingot: 207,
					planks: 384,
					solid_block: 536,

				}
			},
			1: {
				width: 13, height: 9, depth: 10,
				yOffset: 1, depthOffset: 1,
				fixStructure: "mystructure:insta_farm/weeping_vines_fixn",
				structures: "mystructure:insta_farm/weeping_vines_farmn",
				materials: {
					quartz: 32,
					weeping_vines: 32,
					redstone: 120,
					glass: 225,
					iron_ingot: 232,
					planks: 416,
					solid_block: 450,
				}
			}
		}
	}],
	['farm:wool_farm', {
		levels: {
			0: {
				width: 9, height: 7, depth: 8,
				summonEntities: {
					type: "minecraft:sheep",
					positions: [
						{offset: 1, yOffset: 3, depthOffset: 4},
						{offset: -1, yOffset: 3, depthOffset: 4},
						{offset: 1, yOffset: 3, depthOffset: 6},
						{offset: -1, yOffset: 3, depthOffset: 6}
					]
				},
				structures: "mystructure:insta_farm/wool_farm0",
				materials: {
					quartz: 4,
					gold_ingot: 10,
					dirt: 15,
					redstone: 24,
					iron_ingot: 109,
					glass: 138,
					planks: 188,
					solid_block: 194,
				}
			},
			1: {
				width: 9, height: 7, depth: 5,
				depthOffset: 7,
				summonEntities: {
					type: "minecraft:sheep",
					positions: [
						{offset: 1, yOffset: 3, depthOffset: 8},
						{offset: -1, yOffset: 3, depthOffset: 8},
						{offset: 1, yOffset: 3, depthOffset: 10},
						{offset: -1, yOffset: 3, depthOffset: 10}
					]
				},
				structures: "mystructure:insta_farm/wool_farmn",
				materials: {
					gold_ingot: 4,
					quartz: 4,
					dirt: 12,
					redstone: 20,
					iron_ingot: 25,
					planks: 41,
					glass: 103,
					solid_block: 146,
				}
			},
			2: {
				width: 9, height: 7, depth: 5,
				depthOffset: 11,
				summonEntities: {
					type: "minecraft:sheep",
					positions: [
						{offset: 1, yOffset: 3, depthOffset: 12},
						{offset: -1, yOffset: 3, depthOffset: 12},
						{offset: 1, yOffset: 3, depthOffset: 14},
						{offset: -1, yOffset: 3, depthOffset: 14}
					]
				},
				structures: "mystructure:insta_farm/wool_farmn",
				materials: {
					gold_ingot: 4,
					quartz: 4,
					dirt: 12,
					redstone: 20,
					iron_ingot: 25,
					planks: 41,
					glass: 103,
					solid_block: 146,
				}
			},
			3: {
				width: 9, height: 7, depth: 5,
				depthOffset: 15,
				summonEntities: {
					type: "minecraft:sheep",
					positions: [
						{offset: 1, yOffset: 3, depthOffset: 16},
						{offset: -1, yOffset: 3, depthOffset: 16},
						{offset: 1, yOffset: 3, depthOffset: 18},
						{offset: -1, yOffset: 3, depthOffset: 18}
					]
				},
				structures: "mystructure:insta_farm/wool_farmn",
				materials: {
					gold_ingot: 4,
					quartz: 4,
					dirt: 12,
					redstone: 20,
					iron_ingot: 25,
					planks: 41,
					glass: 103,
					solid_block: 146,
				}
			},
			4: {
				width: 9, height: 7, depth: 5,
				depthOffset: 19,
				summonEntities: {
					type: "minecraft:sheep",
					positions: [
						{offset: 1, yOffset: 3, depthOffset: 20},
						{offset: -1, yOffset: 3, depthOffset: 20},
						{offset: 1, yOffset: 3, depthOffset: 22},
						{offset: -1, yOffset: 3, depthOffset: 22}
					]
				},
				structures: "mystructure:insta_farm/wool_farmn",
				materials: {
					gold_ingot: 4,
					quartz: 4,
					dirt: 12,
					redstone: 20,
					iron_ingot: 25,
					planks: 41,
					glass: 103,
					solid_block: 146,
				}
			}
		}
	}],
	['farm:auto_tree_farm', {
		event: "farm:warm_biome_farm",
		onPlaceMessage: 'farm.message.on_place_auto_tree_farm',
		levels: {
			0: {
				width: 21, height: 16, depth: 21,
				offset: 5,
				fixBlocks: [
					{
						type: "minecraft:stone_bricks",
						offsets: [
							{ x: 3, y: 3, z: 10 }
						]
					}
				],
				structures: {
					north: {
						id: "mystructure:insta_farm/auto_tree_farmz",
						rotation: "None"
					},
					south: {
						id: "mystructure:insta_farm/auto_tree_farmx",
						rotation: "Rotate270"
					},
					east: {
						id: "mystructure:insta_farm/auto_tree_farmz",
						rotation: "Rotate90"
					},
					west: {
						id: "mystructure:insta_farm/auto_tree_farmx",
						rotation: "None"
					}
				},
				materials: {
					obsidian: 1,
					water_bucket: 2,
					nether_star: 3,
					wither_skeleton_skull: 3,
					soul_sand: 4,
					honey_block: 4,
					dirt: 30,
					quartz: 56,
					slime_ball: 133,
					ice: 216,
					iron_ingot: 268,
					redstone: 479,
					planks: 704,
					glass: 1264,
					solid_block: 2110,
				}
			}
		}
	}],
	['farm:sheep_farm', {
		event: "farm:no_nether_farm",
		levels: {
			0: {
				width: 19, height: 9, depth: 6,
				structures: "mystructure:insta_farm/sheep_farm0",
				materials: {
					lava_bucket: 1,
					quartz: 1,
					water_bucket: 2,
					redstone: 4,
					iron_ingot: 5,
					planks: 19,
					glass: 127,
					solid_block: 219,
				}
			},
			1: {
				width: 19, height: 7, depth: 4,
				yOffset: 2, depthOffset: 4,
				structures: "mystructure:insta_farm/sheep_farmn",
				materials: {
					water_bucket: 2,
					glass: 71,
					solid_block: 93
				}
			},
			2: {
				width: 19, height: 7, depth: 4,
				yOffset: 2, depthOffset: 6,
				structures: "mystructure:insta_farm/sheep_farmn",
				materials: {
					water_bucket: 2,
					glass: 71,
					solid_block: 93
				}
			},
			3: {
				width: 19, height: 7, depth: 4,
				yOffset: 2, depthOffset: 8,
				structures: "mystructure:insta_farm/sheep_farmn",
				materials: {
					water_bucket: 2,
					glass: 71,
					solid_block: 93
				}
			}
		}
	}],
	['farm:cow_farm', {
		event: "farm:no_nether_farm",
		levels: {
			0: {
				width: 19, height: 9, depth: 6,
				structures: "mystructure:insta_farm/cow_farm0",
				materials: {
					lava_bucket: 1,
					quartz: 1,
					water_bucket: 2,
					redstone: 4,
					iron_ingot: 5,
					planks: 19,
					glass: 127,
					solid_block: 219,
				}
			},
			1: {
				width: 19, height: 7, depth: 4,
				yOffset: 2, depthOffset: 4,
				structures: "mystructure:insta_farm/cow_farmn",
				materials: {
					water_bucket: 2,
					glass: 71,
					solid_block: 93
				}
			},
			2: {
				width: 19, height: 7, depth: 4,
				yOffset: 2, depthOffset: 6,
				structures: "mystructure:insta_farm/cow_farmn",
				materials: {
					water_bucket: 2,
					glass: 71,
					solid_block: 93
				}
			},
			3: {
				width: 19, height: 7, depth: 4,
				yOffset: 2, depthOffset: 8,
				structures: "mystructure:insta_farm/cow_farmn",
				materials: {
					water_bucket: 2,
					glass: 71,
					solid_block: 93
				}
			}
		}
	}],
	['farm:pig_farm', {
		event: "farm:no_nether_farm",
		levels: {
			0: {
				width: 19, height: 8, depth: 6,
				structures: "mystructure:insta_farm/pig_farm0",
				materials: {
					lava_bucket: 1,
					quartz: 1,
					water_bucket: 2,
					redstone: 4,
					iron_ingot: 9,
					planks: 19,
					glass: 92,
					solid_block: 205,
				}
			},
			1: {
				width: 19, height: 6, depth: 4,
				yOffset: 2, depthOffset: 4,
				structures: "mystructure:insta_farm/pig_farmn",
				materials: {
					water_bucket: 2,
					glass: 52,
					solid_block: 85
				}
			},
			2: {
				width: 19, height: 6, depth: 4,
				yOffset: 2, depthOffset: 6,
				structures: "mystructure:insta_farm/pig_farmn",
				materials: {
					water_bucket: 2,
					glass: 52,
					solid_block: 85
				}
			},
			3: {
				width: 19, height: 6, depth: 4,
				yOffset: 2, depthOffset: 8,
				structures: "mystructure:insta_farm/pig_farmn",
				materials: {
					water_bucket: 2,
					glass: 52,
					solid_block: 85
				}
			}
		}
	}],
	['farm:mob_farm', {
		event: "farm:no_nether_farm",
		onPlaceMessage: 'farm.message.on_place_mob_farm',
		levels: {
			0: {
				width: 20, height: 31, depth: 20,
				yOffset: -1, depthOffset: -7,
				structures: {
					north: {
						id: "mystructure:insta_farm/mob_farm0_0",
						rotation: "None"
					},
					south: {
						id: "mystructure:insta_farm/mob_farm0_180",
						rotation: "None"
					},
					east: {
						id: "mystructure:insta_farm/mob_farm0_90",
						rotation: "None"
					},
					west: {
						id: "mystructure:insta_farm/mob_farm0_270",
						rotation: "None"
					}
				},
				materials: {
					water_bucket: 2,
					iron_ingot: 20,
					planks: 251,
					solid_block: 962,
				}
			},
		}
	}],
	['farm:cobblestone_farm', {
		event: "farm:no_nether_farm",
		levels: {
			0: {
				width: 15, height: 23, depth: 17,
				structures: "mystructure:insta_farm/cobblestone_farm0",
				materials: {
					obsidian: 1,
					soul_sand: 1,
					blaze_rod: 1,
					water_bucket: 2,
					quartz: 4,
					lava_bucket: 4,
					ice: 9,
					copper_ingot: 27,
					iron_ingot: 87,
					redstone: 90,
					planks: 193,
					glass: 449,
					solid_block: 811,
				}
			}
		}
	}],
	['farm:basalt_farm', {
		event: "farm:no_nether_farm",
		levels: {
			0: {
				width: 15, height: 24, depth: 17,
				structures: "mystructure:insta_farm/basalt_farm0",
				materials: {
					soul_sand: 1,
					blaze_rod: 1,
					water_bucket: 2,
					quartz: 4,
					lava_bucket: 4,
					obsidian: 17,
					soul_soil: 20,
					slime_ball: 20,
					copper_ingot: 27,
					iron_ingot: 107,
					redstone: 146,
					planks: 258,
					glass: 757,
					solid_block: 991,
					ice: 1629,
				}
			}
		}
	}],
	['farm:honey_farm', {
		levels: {
			0: {
				width: 14, height: 12, depth: 9,
				structures: "mystructure:insta_farm/honey_farm0",
				materials: {
					gold_ingot: 4,
					azalea_leaves_flowered: 10,
					slime_ball: 10,
					quartz: 30,
					iron_ingot: 109,
					redstone: 305,
					glass: 330,
					planks: 364,
					solid_block: 526,
				}
			},
			1: {
				width: 14, height: 10, depth: 6,
				depthOffset: 7,
				structures: "mystructure:insta_farm/honey_farmn",
				fixBlocks: [
					{
						type: "minecraft:rail",
						state: { name: "rail_direction", north: 0, south: 0, west: 1, east: 1 },
						offsets: [
							{ x: 1, y: 8, z: 7 },
							{ x: -2, y: 8, z: 7 },
							{ x: 0, y: 3, z: 7 },
							{ x: -1, y: 3, z: 7 },
							{ x: 0, y: 3, z: 8 },
							{ x: -1, y: 3, z: 8 }
						]
					}
				],
				materials: {
					gold_ingot: 4,
					slime_ball: 10,
					azalea_leaves_flowered: 10,
					quartz: 30,
					iron_ingot: 68,
					glass: 260,
					planks: 296,
					redstone: 313,
					solid_block: 522,
				}
			},
			2: {
				width: 14, height: 10, depth: 6,
				depthOffset: 12,
				structures: "mystructure:insta_farm/honey_farmn",
				fixBlocks: [
					{
						type: "minecraft:rail",
						state: { name: "rail_direction", north: 0, south: 0, west: 1, east: 1 },
						offsets: [
							{ x: 1, y: 8, z: 12 },
							{ x: -2, y: 8, z: 12 },
							{ x: 0, y: 3, z: 12 },
							{ x: -1, y: 3, z: 12 },
							{ x: 0, y: 3, z: 13 },
							{ x: -1, y: 3, z: 13 }
						]
					}
				],
				materials: {
					gold_ingot: 4,
					slime_ball: 10,
					azalea_leaves_flowered: 10,
					quartz: 30,
					iron_ingot: 68,
					glass: 260,
					planks: 296,
					redstone: 313,
					solid_block: 522,
				}
			}
		}
	}],
	['farm:iron_farm', {
		event: "farm:no_village_farm",
		onPlaceMessage: 'farm.message.on_place_iron_farm',
		levels: {
			0: {
				width: 33, height: 9, depth: 33,
				structures: "mystructure:insta_farm/iron_farm0",
				materials: {
					lava_bucket: 1,
					water_bucket: 2,
					flint: 40,
					iron_ingot: 50,
					wool: 60,
					glass: 112,
					planks: 248,
					solid_block: 811,
				}
			}
		}
	}],
	['farm:enderman_farm', {
		event: "farm:end_farm",
		additionalConditions: function(block) {
			const { x, z } = block.location; 
			const isOutsideRestrictedArea = x < -100 || x > 100 || z < -100 || z > 100;
			if (!isOutsideRestrictedArea) {
				getNearestPlayer(block).sendMessage({ translate: 'farm.message.ender_build_outside', with: [ '\n' ] });
				block.dimension.playSound("block.false_permissions", block.center(), { volume: InstaFarmConfig.volume / 100 });
			}
			return isOutsideRestrictedArea;
		},
		onPlaceMessage: 'farm.message.on_place_enderman_farm',
		levels: {
			0: {
				width: 21, height: 44, depth: 21,
				yOffset: -1,
				structures: "mystructure:insta_farm/enderman_farm",
				materials: {
					general_coral_fan: 8,
					iron_ingot: 50,
					leaves: 60,
					planks: 96,
					solid_block: 757,
					glass: 898,
				}
			}
		}
	}],
	['farm:witch_farm', {
		event: "farm:no_nether_farm",
		onPlaceMessage: 'farm.message.on_place_witch_farm',
		levels: {
			0: {
				width: 10, height: 45, depth: 11,
				yOffset: -4, offset: 1, depthOffset: -5,
				structures: "mystructure:insta_farm/witch_farm0",
				materials: {
					trident: 1,
					water_bucket: 2,
					soul_sand: 2,
					redstone: 8,
					iron_ingot: 30,
					planks: 70,
					glass: 263,
					ice: 423,
					solid_block: 618,
				}
			}
		}
	}],
	['farm:tree_farm', {
		levels: {
			0: {
				width: 12, height: 17, depth: 21,
				structures: "mystructure:insta_farm/tree_farm0",
				materials: {
					dirt: 17,
					quartz: 67,
					slime_ball: 143,
					iron_ingot: 279,
					redstone: 514,
					planks: 749,
					glass: 1078,
					solid_block: 1839,
				}
			}
		}
	}],
	['farm:basalt_bridge_maker', {
		event: "farm:nether_farm",
		levels: {
			0: {
				width: 7, height: 9, depth: 6,
				yOffset: -4,
				structures: "mystructure:insta_farm/basalt_bridge_maker0",
				materials: {
					quartz: 2,
					iron_ingot: 3,
					obsidian: 4,
					soul_soil: 5,
					planks: 12,
					redstone: 16,
					glass: 44,
					solid_block: 95,
					slime_ball: 164,
					ice: 243,
				}
			}
		}
	}],
	['farm:basalt_tunnel_maker', {
		event: "farm:nether_farm",
		levels: {
			0: {
				width: 16, height: 9, depth: 28,
				yOffset: -3,
				structures: "mystructure:insta_farm/basalt_tunnel_maker0",
				materials: {
					obsidian: 8,
					soul_soil: 10,
					quartz: 39,
					iron_ingot: 50,
					redstone: 128,
					planks: 153,
					glass: 666,
					slime_ball: 735,
					ice: 810,
					solid_block: 1086,
				}
			}
		}
	}],
	['farm:bartering_farm', {
		event: "farm:nether_farm",
		levels: {
			0: {
				width: 8, height: 7, depth: 8,
				offset: -2,
				structures: {
					north: {
						id: "mystructure:insta_farm/bartering_farm0_0",
						rotation: "None"
					},
					south: {
						id: "mystructure:insta_farm/bartering_farm0_180",
						rotation: "None"
					},
					east: {
						id: "mystructure:insta_farm/bartering_farm0_0",
						rotation: "Rotate90"
					},
					west: {
						id: "mystructure:insta_farm/bartering_farm0_180",
						rotation: "Rotate90"
					}
				},
				materials: {
					mud: 2,
					quartz: 3,
					redstone: 45,
					iron_ingot: 57,
					glass: 127,
					planks: 156,
					solid_block: 187,
				}
			},
			1: {
				width: 5, height: 7, depth: 6,
				offset: 2, depthOffset: 2,
				structures: {
					north: {
						id: "mystructure:insta_farm/bartering_farmn_0",
						rotation: "None"
					},
					south: {
						id: "mystructure:insta_farm/bartering_farmn_180",
						rotation: "None"
					},
					east: {
						id: "mystructure:insta_farm/bartering_farmn_0",
						rotation: "Rotate90"
					},
					west: {
						id: "mystructure:insta_farm/bartering_farmn_180",
						rotation: "Rotate90"
					}
				},
				materials: {
					quartz: 1,
					mud: 2,
					redstone: 21,
					iron_ingot: 35,
					glass: 57,
					solid_block: 85,
					planks: 99,
				}
			},
			2: {
				width: 5, height: 7, depth: 6,
				offset: 4, depthOffset: 2,
				structures: {
					north: {
						id: "mystructure:insta_farm/bartering_farmn_0",
						rotation: "None"
					},
					south: {
						id: "mystructure:insta_farm/bartering_farmn_180",
						rotation: "None"
					},
					east: {
						id: "mystructure:insta_farm/bartering_farmn_0",
						rotation: "Rotate90"
					},
					west: {
						id: "mystructure:insta_farm/bartering_farmn_180",
						rotation: "Rotate90"
					}
				},
				materials: {
					quartz: 1,
					mud: 2,
					redstone: 21,
					iron_ingot: 35,
					glass: 57,
					solid_block: 85,
					planks: 99,
				}
			},
			3: {
				width: 5, height: 7, depth: 6,
				offset: 6, depthOffset: 2,
				structures: {
					north: {
						id: "mystructure:insta_farm/bartering_farmn_0",
						rotation: "None"
					},
					south: {
						id: "mystructure:insta_farm/bartering_farmn_180",
						rotation: "None"
					},
					east: {
						id: "mystructure:insta_farm/bartering_farmn_0",
						rotation: "Rotate90"
					},
					west: {
						id: "mystructure:insta_farm/bartering_farmn_180",
						rotation: "Rotate90"
					}
				},
				materials: {
					quartz: 1,
					mud: 2,
					redstone: 21,
					iron_ingot: 35,
					glass: 57,
					solid_block: 85,
					planks: 99,
				}
			},
			4: {
				width: 5, height: 7, depth: 6,
				offset: 8, depthOffset: 2,
				structures: {
					north: {
						id: "mystructure:insta_farm/bartering_farmn_0",
						rotation: "None"
					},
					south: {
						id: "mystructure:insta_farm/bartering_farmn_180",
						rotation: "None"
					},
					east: {
						id: "mystructure:insta_farm/bartering_farmn_0",
						rotation: "Rotate90"
					},
					west: {
						id: "mystructure:insta_farm/bartering_farmn_180",
						rotation: "Rotate90"
					}
				},
				materials: {
					quartz: 1,
					mud: 2,
					redstone: 21,
					iron_ingot: 35,
					glass: 57,
					solid_block: 85,
					planks: 99,
				}
			},
			5: {
				width: 5, height: 7, depth: 6,
				offset: 10, depthOffset: 2,
				structures: {
					north: {
						id: "mystructure:insta_farm/bartering_farmn_0",
						rotation: "None"
					},
					south: {
						id: "mystructure:insta_farm/bartering_farmn_180",
						rotation: "None"
					},
					east: {
						id: "mystructure:insta_farm/bartering_farmn_0",
						rotation: "Rotate90"
					},
					west: {
						id: "mystructure:insta_farm/bartering_farmn_180",
						rotation: "Rotate90"
					}
				},
				materials: {
					quartz: 1,
					mud: 2,
					redstone: 21,
					iron_ingot: 35,
					glass: 57,
					solid_block: 85,
					planks: 99,
				}
			},
			6: {
				width: 5, height: 7, depth: 6,
				offset: 12, depthOffset: 2,
				structures: {
					north: {
						id: "mystructure:insta_farm/bartering_farmn_0",
						rotation: "None"
					},
					south: {
						id: "mystructure:insta_farm/bartering_farmn_180",
						rotation: "None"
					},
					east: {
						id: "mystructure:insta_farm/bartering_farmn_0",
						rotation: "Rotate90"
					},
					west: {
						id: "mystructure:insta_farm/bartering_farmn_180",
						rotation: "Rotate90"
					}
				},
				materials: {
					quartz: 1,
					mud: 2,
					redstone: 21,
					iron_ingot: 35,
					glass: 57,
					solid_block: 85,
					planks: 99,
				}
			}
		}
	}],
	['farm:shulker_shell_farm', {
		event: "farm:shulker_farm",
		onPlaceMessage: 'farm.message.on_place_shulker_shell_farm',
		levels: {
			0: {
				width: 13, height: 9, depth: 15,
				yOffset: -1, depthOffset: -2,
				structures: "mystructure:insta_farm/shulker_shell_farm0",
				fixBlocks: [
					{
						type: "minecraft:trapdoor",
						state: { name: "direction", north: 0, south: 1, west: 3, east: 2 },
						offsets: [
							{ x: -4, y: 4, z: 4 },
							{ x: -4, y: 4, z: 11 }
						]
					},
					{
						type: "minecraft:trapdoor",
						state: { name: "direction", north: 1, south: 0, west: 2, east: 3 },
						offsets: [
							{ x: 4, y: 4, z: 4 },
							{ x: 4, y: 4, z: 11 }
						]
					}
				],
				materials: {
					water_bucket: 2,
					obsidian: 2,
					quartz: 4,
					blaze_rod: 4,
					gold_ingot: 4,
					soul_sand: 4,
					iron_ingot: 38,
					redstone: 45,
					planks: 74,
					solid_block: 226,
					glass: 532,
				}
			},
			1: {
				width: 13, height: 8, depth: 15,
				depthOffset: 9,
				fixBlocks: [
					{
						type: "minecraft:rail",
						state: { name: "rail_direction", north: 0, south: 0, west: 1, east: 1 },
						offsets: [
							{ x: 4, y: 1, z: 9 },
							{ x: -4, y: 1, z: 9 }
						]
					},
					{
						type: "minecraft:trapdoor",
						state: { name: "direction", north: 0, south: 1, west: 3, east: 2 },
						offsets: [
							{ x: -4, y: 4, z: 15 },
							{ x: -4, y: 4, z: 22 }
						]
					},
					{
						type: "minecraft:trapdoor",
						state: { name: "direction", north: 1, south: 0, west: 2, east: 3 },
						offsets: [
							{ x: 4, y: 4, z: 15 },
							{ x: 4, y: 4, z: 22 }
						]
					}
				],
				structures: "mystructure:insta_farm/shulker_shell_farmn",
				materials: {
					water_bucket: 2,
					obsidian: 2,
					quartz: 4,
					blaze_rod: 4,
					soul_sand: 4,
					gold_ingot: 5,
					iron_ingot: 13,
					planks: 21,
					redstone: 46,
					solid_block: 174,
					glass: 524,
				}
			},
			2: {
				width: 13, height: 8, depth: 15,
				depthOffset: 20,
				fixBlocks: [
					{
						type: "minecraft:rail",
						state: { name: "rail_direction", north: 0, south: 0, west: 1, east: 1 },
						offsets: [
							{ x: 4, y: 1, z: 20 },
							{ x: -4, y: 1, z: 20 }
						]
					},
					{
						type: "minecraft:trapdoor",
						state: { name: "direction", north: 0, south: 1, west: 3, east: 2 },
						offsets: [
							{ x: -4, y: 4, z: 26 },
							{ x: -4, y: 4, z: 33 }
						]
					},
					{
						type: "minecraft:trapdoor",
						state: { name: "direction", north: 1, south: 0, west: 2, east: 3 },
						offsets: [
							{ x: 4, y: 4, z: 26 },
							{ x: 4, y: 4, z: 33 }
						]
					}
				],
				structures: "mystructure:insta_farm/shulker_shell_farmn",
				materials: {
					water_bucket: 2,
					obsidian: 2,
					quartz: 4,
					blaze_rod: 4,
					soul_sand: 4,
					gold_ingot: 5,
					iron_ingot: 13,
					planks: 21,
					redstone: 46,
					solid_block: 174,
					glass: 524,
				}
			}
		}
	}],
	['farm:gold_farm', {
		event: "farm:no_nether_farm",
		levels: {
			0: {
				width: 11, height: 21, depth: 20,
				structures: "mystructure:insta_farm/gold_farm0",
				materials: {
					lava_bucket: 1,
					water_bucket: 2,
					trident: 3,
					slime_ball: 3,
					powder_snow_bucket: 3,
					quartz: 11,
					iron_ingot: 23,
					redstone: 55,
					obsidian: 72,
					ice: 108,
					planks: 151,
					solid_block: 654,
					glass: 971,
				}
			},
			1: {
				width: 11, height: 16, depth: 20,
				yOffset: 5, offset: 6,
				structures: "mystructure:insta_farm/gold_farm1",
				materials: {
					lava_bucket: 1,
					water_bucket: 2,
					iron_ingot: 2,
					slime_ball: 2,
					quartz: 9,
					redstone: 32,
					planks: 39,
					obsidian: 72,
					solid_block: 365,
					glass: 423,
				}
			},
			2: {
				width: 11, height: 16, depth: 20,
				yOffset: 5, offset: -6,
				structures: "mystructure:insta_farm/gold_farm2",
				materials: {
					lava_bucket: 1,
					water_bucket: 2,
					iron_ingot: 2,
					slime_ball: 2,
					quartz: 9,
					redstone: 32,
					planks: 39,
					obsidian: 72,
					solid_block: 375,
					glass: 443,
				}
			}
		}
	}],
	['farm:auto_furnace', {
		event: "farm:no_nether_farm",
		levels: {
			0: {
				dimensions: {
					north: {
						width: 22, height: 15, depth: 25,
						offset: -6, depthOffset: 1,
						fixBlocks: [
							{
								type: "minecraft:detector_rail",
								state: { name: "rail_direction", north: 3 },
								offsets: [
									{ x: -1, y: 11, z: 20 }
								]
							}
						],
						structures: { north: { id: "mystructure:insta_farm/auto_furnace_00", rotation: "None" } }
					},
					south: {
						width: 22, height: 15, depth: 25,
						offset: -6, depthOffset: 1,
						fixBlocks: [
							{
								type: "minecraft:detector_rail",
								state: { name: "rail_direction", south: 2 },
								offsets: [
									{ x: -1, y: 11, z: 20 }
								]
							}
						],
						structures: { south: { id: "mystructure:insta_farm/auto_furnace_00", rotation: "Rotate180" } }
					},
					east: {
						width: 25, height: 15, depth: 22,
						depthOffset: 1,
						fixBlocks: [
							{
								type: "minecraft:detector_rail",
								state: { name: "rail_direction", east: 2 },
								offsets: [
									{ x: -6, y: 11, z: 6 }
								]
							}
						],
						structures: { east: { id: "mystructure:insta_farm/auto_furnace_900", rotation: "Rotate180" } }
					},
					west: {
						width: 25, height: 15, depth: 22,
						depthOffset: 1,
						fixBlocks: [
							{
								type: "minecraft:detector_rail",
								state: { name: "rail_direction", west: 3 },
								offsets: [
									{ x: -6, y: 11, z: 6 }
								]
							}
						],
						structures: { west: { id: "mystructure:insta_farm/auto_furnace_900", rotation: "None" } }
					}
				},
				materials: {
					blaze_rod: 1,
					water_bucket: 2,
					slime_ball: 2,
					soul_sand: 2,
					quartz: 18,
					copper_ingot: 27,
					ice: 36,
					gold_ingot: 91,
					redstone: 255,
					iron_ingot: 600,
					planks: 1108,
					solid_block: 1523,
					glass: 1792,
				}
			},
			1: {
				dimensions: {
					north: {
						width: 15, height: 15, depth: 18,
						offset: -17, depthOffset: 1,
						addItemToBlock: [
							{
								id: "minecraft:fern",
								quantity: 4,
								offset: { x: -4, y: 4, z: 8 }
							},
							{
								id: "minecraft:fern",
								quantity: 69,
								offset: { x: -3, y: 11, z: 22 }
							}
						],
						structures: { north: { id: "mystructure:insta_farm/auto_furnacen", rotation: "None" } }
					},
					south: {
						width: 15, height: 15, depth: 18,
						offset: -17, depthOffset: 1,
						addItemToBlock: [
							{
								id: "minecraft:fern",
								quantity: 4,
								offset: { x: -4, y: 4, z: 8 }
							},
							{
								id: "minecraft:fern",
								quantity: 69,
								offset: { x: -3, y: 11, z: 22 }
							}
						],
						structures: { south: { id: "mystructure:insta_farm/auto_furnacen", rotation: "Rotate180" } }
					},
					east: {
						width: 18, height: 15, depth: 15,
						offset: -4, depthOffset: 16,
						addItemToBlock: [
							{
								id: "minecraft:fern",
								quantity: 4,
								offset: { x: 6, y: 4, z: 3 }
							},
							{
								id: "minecraft:fern",
								quantity: 69,
								offset: { x: -8, y: 11, z: 4 }
							}
						],
						structures: { east: { id: "mystructure:insta_farm/auto_furnacen", rotation: "Rotate180" } }
					},
					west: {
						width: 18, height: 15, depth: 15,
						offset: -4, depthOffset: 16,
						addItemToBlock: [
							{
								id: "minecraft:fern",
								quantity: 4,
								offset: { x: 6, y: 4, z: 3 }
							},
							{
								id: "minecraft:fern",
								quantity: 69,
								offset: { x: -8, y: 11, z: 4 }
							}
						],
						structures: { west: { id: "mystructure:insta_farm/auto_furnacen", rotation: "None" } }
					}
				},
				materials: {
					water_bucket: 2,
					quartz: 8,
					ice: 36,
					gold_ingot: 64,
					redstone: 103,
					iron_ingot: 484,
					glass: 588,
					solid_block: 602,
					planks: 802,
				},
			},
			2: {
				dimensions: {
					north: {
						width: 15, height: 15, depth: 18,
						offset: -25, depthOffset: 1,
						addItemToBlock: [
							{
								id: "minecraft:fern",
								quantity: 4,
								offset: { x: -4, y: 4, z: 8 }
							},
							{
								id: "minecraft:fern",
								quantity: 45,
								offset: { x: -3, y: 11, z: 22 }
							}
						],
						structures: { north: { id: "mystructure:insta_farm/auto_furnacen", rotation: "None" } },
					},
					south: {
						width: 15, height: 15, depth: 18,
						offset: -25, depthOffset: 1,
						addItemToBlock: [
							{
								id: "minecraft:fern",
								quantity: 4,
								offset: { x: -4, y: 4, z: 8 }
							},
							{
								id: "minecraft:fern",
								quantity: 45,
								offset: { x: -3, y: 11, z: 22 }
							}
						],
						structures: { south: { id: "mystructure:insta_farm/auto_furnacen", rotation: "Rotate180" } },
					},
					east: {
						width: 18, height: 15, depth: 15,
						offset: -4, depthOffset: 24,
						addItemToBlock: [
							{
								id: "minecraft:fern",
								quantity: 4,
								offset: { x: 6, y: 4, z: 3 }
							},
							{
								id: "minecraft:fern",
								quantity: 45,
								offset: { x: -8, y: 11, z: 4 }
							}
						],
						structures: { east: { id: "mystructure:insta_farm/auto_furnacen", rotation: "Rotate180" } }
					},
					west: {
						width: 18, height: 15, depth: 15,
						offset: -4, depthOffset: 24,
						addItemToBlock: [
							{
								id: "minecraft:fern",
								quantity: 4,
								offset: { x: 6, y: 4, z: 3 }
							},
							{
								id: "minecraft:fern",
								quantity: 45,
								offset: { x: -8, y: 11, z: 4 }
							}
						],
						structures: { west: { id: "mystructure:insta_farm/auto_furnacen", rotation: "None" } }
					}
				},
				materials: {
					water_bucket: 2,
					quartz: 8,
					ice: 36,
					gold_ingot: 64,
					redstone: 103,
					iron_ingot: 484,
					glass: 588,
					solid_block: 602,
					planks: 802,
				},
			},
			3: {
				dimensions: {
					north: {
						width: 15, height: 15, depth: 18,
						offset: -33, depthOffset: 1,
						addItemToBlock: [
							{
								id: "minecraft:fern",
								quantity: 4,
								offset: { x: -4, y: 4, z: 8 }
							},
							{
								id: "minecraft:fern",
								quantity: 69,
								offset: { x: -3, y: 11, z: 22 }
							}
						],
						structures: { north: { id: "mystructure:insta_farm/auto_furnacen", rotation: "None" } },
					},
					south: {
						width: 15, height: 15, depth: 18,
						offset: -33, depthOffset: 1,
						addItemToBlock: [
							{
								id: "minecraft:fern",
								quantity: 4,
								offset: { x: -4, y: 4, z: 8 }
							},
							{
								id: "minecraft:fern",
								quantity: 69,
								offset: { x: -3, y: 11, z: 22 }
							}
						],
						structures: { south: { id: "mystructure:insta_farm/auto_furnacen", rotation: "Rotate180" } },
					},
					east: {
						width: 18, height: 15, depth: 15,
						offset: -4, depthOffset: 32,
						addItemToBlock: [
							{
								id: "minecraft:fern",
								quantity: 4,
								offset: { x: 6, y: 4, z: 3 }
							},
							{
								id: "minecraft:fern",
								quantity: 69,
								offset: { x: -8, y: 11, z: 4 }
							}
						],
						structures: { east: { id: "mystructure:insta_farm/auto_furnacen", rotation: "Rotate180" } }
					},
					west: {
						width: 18, height: 15, depth: 15,
						offset: -4, depthOffset: 32,
						addItemToBlock: [
							{
								id: "minecraft:fern",
								quantity: 4,
								offset: { x: 6, y: 4, z: 3 }
							},
							{
								id: "minecraft:fern",
								quantity: 69,
								offset: { x: -8, y: 11, z: 4 }
							}
						],
						structures: { west: { id: "mystructure:insta_farm/auto_furnacen", rotation: "None" } }
					}
				},
				materials: {
					water_bucket: 2,
					quartz: 8,
					ice: 36,
					gold_ingot: 64,
					redstone: 103,
					iron_ingot: 484,
					glass: 588,
					solid_block: 602,
					planks: 802,
				},
			}
		}
	}],
	['farm:creeper_farm', {
		event: "farm:no_nether_farm",
		onPlaceMessage: 'farm.message.on_place_creeper_farm',
		levels: {
			0: {
				width: 49, height: 44, depth: 49,
				fixStructure: "mystructure:insta_farm/creeper_farm_fix",
				structures: "mystructure:insta_farm/creeper_farm0",
				materials: {
					water_bucket: 2,
					trident: 8,
					iron_ingot: 8,
					magma: 8,
					redstone: 149,
					glass: 722,
					solid_block: 5381,
					ice: 6221,
					planks: 10719,
				}
			}
		}
	}],
	['farm:froglight_spawner_farm', {
		event: "farm:nether_farm",
		additionalConditions: function(block) {
			const direction = block.permutation.getState("minecraft:cardinal_direction");
			const backBlock = block.offset(backBlockLocation[direction]);
			if (backBlock.typeId !== "minecraft:mob_spawner") {
				getNearestPlayer(block).sendMessage({ translate: 'farm.message.froglight_farm_generation', with: [ '\n' ] });
				block.dimension.playSound("block.false_permissions", block.center(), { volume: InstaFarmConfig.volume / 100 });
			}
			return backBlock.typeId === "minecraft:mob_spawner";
		},
		levels: {
			0: {
				width: 11, height: 13, depth: 14,
				yOffset: -8, depthOffset: -8,
				structures: "mystructure:insta_farm/froglight_farm",
				teleportPlayer: { x: 0, y: -6, z: -6 },
				materials: {
					powder_snow_bucket: 16,
					solid_block: 348,
					iron_ingot: 504,
					glass: 520,
					planks: 725,
				}
			}
		}
	}],
	['farm:lava_farm', {
		levels: {
			0: {
				width: 15, height: 7, depth: 10,
				structures: "mystructure:insta_farm/lava_farm0",
				materials: {
					slime_ball: 1,
					quartz: 2,
					pointed_dripstone: 22,
					lava_bucket: 22,
					redstone: 54,
					planks: 66,
					iron_ingot: 148,
					glass: 236,
					solid_block: 366,
				}
			},
			1: {
				width: 15, height: 7, depth: 8,
				depthOffset: 6,
				structures: "mystructure:insta_farm/lava_farm1",
				materials: {
					planks: 20,
					pointed_dripstone: 23,
					lava_bucket: 23,
					redstone: 50,
					glass: 137,
					iron_ingot: 145,
					solid_block: 202,
				}
			},
			2: {
				width: 15, height: 7, depth: 8,
				depthOffset: 10,
				structures: "mystructure:insta_farm/lava_farm1",
				materials: {
					planks: 20,
					pointed_dripstone: 23,
					lava_bucket: 23,
					redstone: 50,
					glass: 137,
					iron_ingot: 145,
					solid_block: 202,
				}
			},
			3: {
				width: 15, height: 7, depth: 8,
				depthOffset: 14,
				structures: "mystructure:insta_farm/lava_farm2",
				materials: {
					slime_ball: 10,
					lava_bucket: 23,
					pointed_dripstone: 23,
					planks: 24,
					redstone: 54,
					glass: 137,
					iron_ingot: 139,
					solid_block: 210,
				}
			},
			4: {
				width: 15, height: 7, depth: 8,
				depthOffset: 18,
				structures: "mystructure:insta_farm/lava_farm1",
				materials: {
					planks: 20,
					pointed_dripstone: 23,
					lava_bucket: 23,
					redstone: 50,
					glass: 137,
					iron_ingot: 145,
					solid_block: 202,
				}
			}
		}
	}],
	['farm:snow_farm', {
		event: "farm:warm_biome_farm",
		levels: {
			0: {
				width: 8, height: 6, depth: 6,
				structures: "mystructure:insta_farm/snow_farm",
				materials: {
					quartz: 3,
					redstone: 38,
					iron_ingot: 44,
					planks: 95,
					glass: 100,
					solid_block: 148,
				}
			}
		}
	}],
	['farm:slime_farm', {
		event: "farm:no_nether_farm",
		onPlaceMessage: 'farm.message.on_place_slime_farm',
		levels: {
			0: {
				width: 13, height: 16, depth: 10,
				structures: {
					north: {
						id: "mystructure:insta_farm/slime_farm_0",
						rotation: "None"
					},
					south: {
						id: "mystructure:insta_farm/slime_farm_180",
						rotation: "None"
					},
					east: {
						id: "mystructure:insta_farm/slime_farm_90",
						rotation: "None"
					},
					west: {
						id: "mystructure:insta_farm/slime_farm_270",
						rotation: "None"
					}
				},
				materials: {
					sand: 1,
					cactus: 1,
					water_bucket: 2,
					soul_sand: 2,
					campfire: 9,
					redstone: 89,
					iron_ingot: 165,
					solid_block: 435,
					planks: 442,
					glass: 680,
				}
			}
		}
	}],
	['farm:trident_farm', {
		event: "farm:ocean_farm",
		onPlaceMessage: 'farm.message.on_place_trident_farm',
		levels: {
			0: {
				width: 51, height: 54, depth: 36,
				structures: "mystructure:insta_farm/trident_farm",
				materials: {
					trident: 2,
					water_bucket: 2,
					quartz: 12,
					soul_sand: 16,
					iron_ingot: 68,
					redstone: 167,
					planks: 296,
					glass: 371,
					ice: 720,
					leaves: 1188,
					solid_block: 2254,
				}
			}
		}
	}],
	['farm:ice_farm_fm', {
		event: "farm:frozen_biome_farm",
		levels: {
			0: {
				width: 7, height: 18, depth: 32,
				structures: "mystructure:insta_farm/ice_farm0",
				materials: {
					coal: 1,
					glass: 1,
					water_bucket: 2,
					obsidian: 2,
					general_terracotta: 2,
					iron_ingot: 7,
					quartz: 9,
					redstone: 55,
					slime_ball: 83,
					ice: 86,
					planks: 178,
					solid_block: 308,
				}
			},
			1: {
				width: 7, height: 18, depth: 32,
				offset: 7,
				structures: "mystructure:insta_farm/ice_farm1",
				materials: {
					coal: 1,
					glass: 1,
					water_bucket: 2,
					obsidian: 2,
					general_terracotta: 2,
					iron_ingot: 7,
					quartz: 8,
					redstone: 57,
					slime_ball: 83,
					ice: 86,
					planks: 172,
					solid_block: 297,
				}
			},
			2: {
				width: 13, height: 18, depth: 32,
				offset: -4,
				structures: "mystructure:insta_farm/ice_farm2",
				materials: {
					coal: 1,
					glass: 1,
					water_bucket: 2,
					obsidian: 2,
					general_terracotta: 2,
					iron_ingot: 7,
					quartz: 8,
					redstone: 58,
					slime_ball: 83,
					ice: 86,
					planks: 172,
					solid_block: 297,
				}
			}
		}
	}],
	['farm:ice_farm_n', {
		event: "farm:frozen_biome_farm",
		levels: {
			0: {
				width: 31, height: 5, depth: 7,
				structures: "mystructure:insta_farm/ice_farm_n0",
				materials: {
					water_bucket: 2,
					slime_ball: 10,
					quartz: 20,
					iron_ingot: 20,
					planks: 70,
					redstone: 100,
					glass: 139,
					solid_block: 559,
				}
			},
			1: {
				width: 31, height: 5, depth: 6,
				depthOffset: 6, 
				structures: "mystructure:insta_farm/ice_farm_nn",
				materials: {
					water_bucket: 2,
					slime_ball: 10,
					quartz: 20,
					iron_ingot: 20,
					planks: 75,
					glass: 91,
					redstone: 100,
					solid_block: 479,
				}
			},
			2: {
				width: 31, height: 5, depth: 6,
				depthOffset: 11, 
				structures: "mystructure:insta_farm/ice_farm_nn",
				materials: {
					water_bucket: 2,
					slime_ball: 10,
					quartz: 20,
					iron_ingot: 20,
					planks: 75,
					glass: 91,
					redstone: 100,
					solid_block: 479,
				}
			},
			3: {
				width: 31, height: 5, depth: 6,
				depthOffset: 16, 
				structures: "mystructure:insta_farm/ice_farm_nn",
				materials: {
					water_bucket: 2,
					slime_ball: 10,
					quartz: 20,
					iron_ingot: 20,
					planks: 75,
					glass: 91,
					redstone: 100,
					solid_block: 479,
				}
			}
		}
	}],
	['farm:raid_farm', {
		event: "farm:raid_farm",
		onPlaceMessage: 'farm.message.on_place_raid_farm',
		levels: {
			0: {
				width: 12, height: 11, depth: 12,
				structures: "mystructure:insta_farm/raid_farm",
				materials: {
					trident: 1,
					general_coral_fan: 1,
					water_bucket: 2,
					lava_bucket: 4,
					quartz: 4,
					wool: 3,
					redstone: 16,
					iron_ingot: 24,
					leaves: 77,
					planks: 120,
					glass: 233,
					solid_block: 294,
				}
			}
		}
	}],
	['farm:crimson_roots_farm', {
		event: "farm:no_nether_farm",
		levels: {
			0: {
				width: 14, height: 7, depth: 13,
				offset: -1,
				structures: "mystructure:insta_farm/crimson_roots_f0",
				materials: {
					water_bucket: 7,
					quartz: 7,
					netherrack: 56,
					iron_ingot: 86,
					redstone: 122,
					planks: 218,
					glass: 377,
					solid_block: 448,
				}
			},
			1: {
				width: 19, height: 7, depth: 13,
				offset: 8,
				structures: "mystructure:insta_farm/crimson_roots_f1",
				materials: {
					quartz: 2,
					water_bucket: 7,
					netherrack: 56,
					redstone: 73,
					iron_ingot: 134,
					planks: 287,
					glass: 308,
					solid_block: 335,
				}
			}
		}
	}],
	['farm:warped_roots_farm', {
		event: "farm:no_nether_farm",
		levels: {
			0: {
				width: 14, height: 7, depth: 13,
				offset: -1,
				structures: "mystructure:insta_farm/warped_roots_f0",
				materials: {
					water_bucket: 7,
					quartz: 7,
					netherrack: 56,
					iron_ingot: 86,
					redstone: 122,
					planks: 218,
					glass: 377,
					solid_block: 448,
				}
			},
			1: {
				width: 19, height: 7, depth: 13,
				offset: 8,
				structures: "mystructure:insta_farm/warped_roots_f1",
				materials: {
					quartz: 2,
					water_bucket: 7,
					netherrack: 56,
					redstone: 73,
					iron_ingot: 134,
					planks: 287,
					glass: 308,
					solid_block: 335,
				}
			}
		}
	}],
	['farm:resin_farm', {
		event: "farm:no_nether_farm",
		onPlaceMessage: 'farm.message.on_place_resin_farm',
		levels: {
			0: {
				width: 11, height: 13, depth: 16,
				depthOffset: -1,
				structures: "mystructure:insta_farm/resin_farm0",
				materials: {
					water_bucket: 2,
					quartz: 3,
					trident: 4,
					creaking_heart: 4,
					iron_ingot: 39,
					leaves: 64,
					redstone: 90,
					solid_block: 123,
					planks: 128,
					glass: 244,
				}
			},
			1: {
				width: 11, height: 12, depth: 10,
				yOffset: 1, depthOffset: 9,
				structures: "mystructure:insta_farm/resin_farm1",
				materials: {
					water_bucket: 2,
					trident: 4,
					creaking_heart: 4,
					iron_ingot: 8,
					redstone: 26,
					planks: 28,
					leaves: 34,
					solid_block: 48,
					glass: 115,
				}
			},
			2: {
				width: 11, height: 11, depth: 10,
				yOffset: 2, depthOffset: 13,
				structures: "mystructure:insta_farm/resin_farm2",
				materials: {
					water_bucket: 2,
					trident: 4,
					creaking_heart: 4,
					iron_ingot: 8,
					redstone: 28,
					planks: 29,
					leaves: 34,
					solid_block: 51,
					glass: 111,
				}
			}
		}
	}]
]);
export const selectFarmMap = new Map([
	['farm:ice_farm', [
		{ farmId: 'farm:ice_farm_n', farmName: { translate: 'farm.ice_farm_n.name' }, button: 'button_ice' },
		{ farmId: 'farm:ice_farm_fm', farmName: { translate: 'farm.ice_farm_fm.name' }, button: 'button_ice' }
	]],
	['farm:bamboo_farm', [
		{ farmId: 'farm:bamboo_farm_n', farmName: { translate: 'farm.bamboo_farm_n.name' }, button: 'button_bamboo' },
		{ farmId: 'farm:bamboo_farm_fm', farmName: { translate: 'farm.bamboo_farm_fm.name' }, button: 'button_bamboo' }
	]],
	['farm:sugar_cane_farm', [
		{ farmId: 'farm:sugar_cane_farm_n', farmName: { translate: 'farm.sugar_cane_farm_n.name' }, button: 'button_sugar_cane' },
		{ farmId: 'farm:sugar_cane_farm_fm', farmName: { translate: 'farm.sugar_cane_farm_fm.name' }, button: 'button_sugar_cane' }
	]],
	['farm:twisting_vines_farm', [
		{ farmId: 'farm:twisting_vines_farm_n', farmName: { translate: 'farm.twisting_vines_farm_n.name' }, button: 'button_twisting_v' },
		{ farmId: 'farm:twisting_vines_farm_fm', farmName: { translate: 'farm.twisting_vines_farm_fm.name' }, button: 'button_twisting_v' }
	]],
	['farm:redstone_mechanisms', [
		{ farmId: 'farm:basalt_bridge_maker', farmName: { translate: 'farm.basalt_bridge_maker.name' }, button: 'button_basalt' },
		{ farmId: 'farm:basalt_tunnel_maker', farmName: { translate: 'farm.basalt_tunnel_maker.name' }, button: 'button_basalt' }
	]]
]);
function getNearestPlayer(block) {
	return block.dimension.getPlayers({ closest: 1, location: block.location })[0];
}